stages:
    - build
    - run

compile-pipeline:
    stage: build
    image: registry.gitlab.com/lavcorps-line/infrastructure/alpine-dockers/3.16:stable
    variables:
        DHALL_VERSION: "1.41.1"
    script:
        - |
            printf "\n${COLOR_F_MAGENTA_D}Initializing...${COLOR_F_DEFAULT}\n"
            apk add curl
            curl -L https://github.com/dhall-lang/dhall-haskell/releases/download/${DHALL_VERSION}/dhall-${DHALL_VERSION}-x86_64-linux.tar.bz2 > dhall.tar.bz2
            tar xjvf dhall.tar.bz2
        - ./bin/dhall text --file ./.gitlab-ci.dhall > pipeline.yml
    artifacts:
        paths:
            - pipeline.yml

execute-pipeline:
    stage: run
    needs:
        - compile-pipeline
    variables:
        OG_COMMIT_TAG: $CI_COMMIT_TAG
        OG_PIPELINE_SOURCE: $CI_PIPELINE_SOURCE
    trigger:
        include:
            - artifact: pipeline.yml
              job: compile-pipeline
        strategy: depend
